'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_rollupPluginBabelHelpers-a9d50a9f.js');
var emotion = require('emotion');
var Box = require('reakit-system-palette/Box');

function _templateObject() {
  var data = _rollupPluginBabelHelpers._taggedTemplateLiteralLoose(["\n    align-items: center;\n    justify-content: center;\n    padding: 0.375em 0.75em;\n    font-size: 100%;\n    border: 0;\n    color: inherit;\n    background-color: inherit;\n\n    [aria-activedescendant=\"", "\"]:focus &[aria-selected=\"true\"],\n    [aria-activedescendant=\"", "\"]:focus ~ * &[aria-selected=\"true\"] {\n      color: ", ";\n      background-color ", ";\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function useCompositeItemOptions(_ref) {
  var _ref$unstable_system = _ref.unstable_system;
  _ref$unstable_system = _ref$unstable_system === void 0 ? {} : _ref$unstable_system;

  var _ref$unstable_system$ = _ref$unstable_system.fill,
      fill = _ref$unstable_system$ === void 0 ? "opaque" : _ref$unstable_system$,
      _ref$unstable_system$2 = _ref$unstable_system.palette,
      palette = _ref$unstable_system$2 === void 0 ? "primary" : _ref$unstable_system$2,
      system = _rollupPluginBabelHelpers._objectWithoutPropertiesLoose(_ref$unstable_system, ["fill", "palette"]),
      options = _rollupPluginBabelHelpers._objectWithoutPropertiesLoose(_ref, ["unstable_system"]);

  return _rollupPluginBabelHelpers._objectSpread2({
    unstable_system: _rollupPluginBabelHelpers._objectSpread2({
      fill: fill,
      palette: palette
    }, system)
  }, options);
}
function useCompositeItemProps(_ref2, htmlProps) {
  var unstable_system = _ref2.unstable_system,
      id = _ref2.id;

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _usePaletteBoxProps = Box.useBoxProps({
    unstable_system: unstable_system
  }),
      _usePaletteBoxProps$s = _usePaletteBoxProps.style,
      color = _usePaletteBoxProps$s.color,
      backgroundColor = _usePaletteBoxProps$s.backgroundColor;

  var compositeItem = emotion.css(_templateObject(), id, id, color, backgroundColor);
  return _rollupPluginBabelHelpers._objectSpread2({}, htmlProps, {
    className: emotion.cx(compositeItem, htmlProps.className)
  });
}

exports.useCompositeItemOptions = useCompositeItemOptions;
exports.useCompositeItemProps = useCompositeItemProps;
