'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_rollupPluginBabelHelpers-a9d50a9f.js');
var emotion = require('emotion');
var Box = require('reakit-system-palette/Box');
var contrast = require('reakit-system-palette/utils/contrast');
var fade = require('reakit-system-palette/utils/fade');

function _templateObject() {
  var data = _rollupPluginBabelHelpers._taggedTemplateLiteralLoose(["\n    [data-arrow] {\n      background-color: transparent;\n      & .stroke {\n        fill: ", ";\n      }\n      & .fill {\n        fill: ", ";\n      }\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function usePopoverOptions(_ref) {
  var _ref$unstable_system = _ref.unstable_system;
  _ref$unstable_system = _ref$unstable_system === void 0 ? {} : _ref$unstable_system;

  var _ref$unstable_system$ = _ref$unstable_system.palette,
      palette = _ref$unstable_system$ === void 0 ? "background" : _ref$unstable_system$,
      _ref$unstable_system$2 = _ref$unstable_system.fill,
      fill = _ref$unstable_system$2 === void 0 ? "opaque" : _ref$unstable_system$2,
      system = _rollupPluginBabelHelpers._objectWithoutPropertiesLoose(_ref$unstable_system, ["palette", "fill"]),
      options = _rollupPluginBabelHelpers._objectWithoutPropertiesLoose(_ref, ["unstable_system"]);

  return _rollupPluginBabelHelpers._objectSpread2({
    unstable_system: _rollupPluginBabelHelpers._objectSpread2({
      palette: palette,
      fill: fill
    }, system)
  }, options);
}
function usePopoverProps(_ref2, htmlProps) {
  var unstable_system = _ref2.unstable_system;

  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _usePaletteBoxProps = Box.useBoxProps({
    unstable_system: unstable_system
  }),
      backgroundColor = _usePaletteBoxProps.style.backgroundColor;

  var foreground = contrast.useContrast(backgroundColor) || "black";
  var borderColor = fade.useFade(foreground, 0.75);
  var popover = emotion.css(_templateObject(), borderColor, backgroundColor);
  return _rollupPluginBabelHelpers._objectSpread2({}, htmlProps, {
    className: emotion.cx(popover, htmlProps.className)
  });
}
function usePopoverArrowProps(_, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  return _rollupPluginBabelHelpers._objectSpread2({
    "data-arrow": ""
  }, htmlProps);
}

exports.usePopoverArrowProps = usePopoverArrowProps;
exports.usePopoverOptions = usePopoverOptions;
exports.usePopoverProps = usePopoverProps;
