'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_rollupPluginBabelHelpers-a9d50a9f.js');
var emotion = require('emotion');
var fade = require('reakit-system-palette/utils/fade');
var palette$1 = require('reakit-system-palette/utils/palette');

function _templateObject() {
  var data = _rollupPluginBabelHelpers._taggedTemplateLiteralLoose(["\n    border: 1px solid ", ";\n    border-width: 0 1px 0 0;\n    margin: 0 0.5em;\n    padding: 0;\n    width: 0;\n    height: auto;\n\n    &[aria-orientation=\"horizontal\"] {\n      border-width: 0 0 1px 0;\n      margin: 0.5em 0;\n      width: auto;\n      height: 0;\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function useSeparatorProps(_, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var foreground = palette$1.usePalette("foreground") || "black";
  var borderColor = fade.useFade(foreground, 0.75);
  var separator = emotion.css(_templateObject(), borderColor);
  return _rollupPluginBabelHelpers._objectSpread2({}, htmlProps, {
    className: emotion.cx(separator, htmlProps.className)
  });
}

exports.useSeparatorProps = useSeparatorProps;
