'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_rollupPluginBabelHelpers-a9d50a9f.js');
var emotion = require('emotion');
var Box = require('reakit-system-palette/Box');
var darken = require('reakit-system-palette/utils/darken');
var contrast = require('reakit-system-palette/utils/contrast');
var fade = require('reakit-system-palette/utils/fade');
var palette$1 = require('reakit-system-palette/utils/palette');
var lighten = require('reakit-system-palette/utils/lighten');
var isLight = require('reakit-system-palette/utils/isLight');

function _templateObject() {
  var data = _rollupPluginBabelHelpers._taggedTemplateLiteralLoose(["\n    &:not([type=\"checkbox\"]):not([type=\"radio\"]) {\n      transition: box-shadow 0.15s ease-in-out;\n      outline: 0;\n\n      &:focus {\n        box-shadow: 0 0 0 0.2em ", ";\n        position: relative;\n        z-index: 2;\n      }\n\n      &:hover {\n        z-index: 2;\n      }\n    }\n\n    &[aria-disabled=\"true\"] {\n      opacity: 0.5;\n    }\n  "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
function useTabbableProps(_ref, htmlProps) {
  if (htmlProps === void 0) {
    htmlProps = {};
  }

  var _ref$unstable_system = _ref.unstable_system;
  _ref$unstable_system = _ref$unstable_system === void 0 ? {} : _ref$unstable_system;

  var _ref$unstable_system$ = _ref$unstable_system.palette,
      palette = _ref$unstable_system$ === void 0 ? "primary" : _ref$unstable_system$,
      system = _rollupPluginBabelHelpers._objectWithoutPropertiesLoose(_ref$unstable_system, ["palette"]);

  var _usePaletteBoxProps = Box.useBoxProps({
    unstable_system: _rollupPluginBabelHelpers._objectSpread2({
      palette: palette
    }, system)
  }),
      _usePaletteBoxProps$s = _usePaletteBoxProps.style,
      color = _usePaletteBoxProps$s.color,
      backgroundColor = _usePaletteBoxProps$s.backgroundColor;

  var dark = palette$1.usePalette("dark") || "black";
  var background = palette$1.usePalette("background") || "white";
  var backgroundIsLight = isLight.useIsLight(background);
  var strokeColor = backgroundColor || color || dark;
  var contrastRatio = contrast.useContrastRatio(background, strokeColor);
  var darker = darken.useDarken(strokeColor, contrastRatio < 1.2 ? 0.25 : 0);
  var lighter = lighten.useLighten(strokeColor, contrastRatio < 1.2 ? 0.25 : 0);
  var boxShadowColor = fade.useFade(backgroundIsLight ? darker : lighter, 0.6);
  var tabbable = emotion.css(_templateObject(), boxShadowColor);
  return _rollupPluginBabelHelpers._objectSpread2({}, htmlProps, {
    className: emotion.cx(tabbable, htmlProps.className)
  });
}

exports.useTabbableProps = useTabbableProps;
